# Generierung eines Versuchsplans mit R (Cola_Versuchsplan.r)
# Vollstndiger Versuchsplan mit Berechnung der D-Effizienz:
all=expand.grid(A=c("1","2","3"),B=c("1","2","3","4"),
                C=c("1","2","3"),D=c("1","2"),
                E=c("1","2","3","4"),F=c("1","2","3","4"))
set.seed(1); n=dim(all)[1]; library(AlgDesign)
plan.all=optFederov(~.,data=all,nTrials=n); plan.all$D
# Reduzierter Versuchsplan nach Federov:
plan.red=optFederov(~.,data=all,nTrials=25,nRepeats=100)
plan.red$design; plan.red$D; plan.red$D/plan.all$D
# (zustzliche) "von Hand"-Berechnung der D-Effizienz:
X=as.matrix(model.matrix(~.,all)); n=dim(X)[1]
XsX=t(X)%*%X; XsXinv=solve(XsX); m=dim(X)[2]
plan.all.D=1/(n*det(XsXinv)**(1/m)); plan.all.D
X=as.matrix(model.matrix(~.,plan.red$design)); n=dim(X)[1]
XsX=t(X)%*%X; XsXinv=solve(XsX); m=dim(X)[2]
plan.red.D=1/(n*det(XsXinv)**(1/m)); plan.red.D
plan.red.D/plan.all.D
