# Simulationsrechnungen zu X, Beta, w, d, f, Regel, alpha
# Regel=1: First-Choice-Regel, =2: BTL-, =3: Logit-Regel
# Funktion zur Berechnung von Auswahlwahrscheinlichkeiten
Prob=function(X,Beta,Regel=1,alpha=1){
  u=Beta %*% t(X); Prob=u; I=dim(Beta)[1]; J=dim(X)[1]
  for (i in 1:I){
    if (Regel==1){alpha=50}
    if (Regel<=2){usum=sum(u[i,]**alpha);
    for (j in 1:J){Prob[i,j]=(u[i,j]**alpha)/usum}} else
      {usum=sum(exp(alpha*u[i,]));
    for (j in 1:J){Prob[i,j]=(exp(alpha*u[i,j]))/usum}}
  }
return(Prob)}

# Funktion zur Berechnung von Abstzen
Absatz=function(X,Beta,w,Regel=1,alpha=1){
  I=dim(Beta)[1]; J=dim(X)[1]; Absatz=1:J
  P=Prob(X,Beta,Regel,alpha)
  for (j in 1:J){Absatz[j]=0
  for (i in 1:I){Absatz[j]=Absatz[j]+w[i]*P[i,j]}}
return(Absatz)}

# Funktion zur Berechnung von Marktanteilen
Marktanteil=function(X,Beta,w,Regel=1,alpha=1){
  J=dim(X)[1]
  A=Absatz(X,Beta,w,Regel,alpha); Asum=sum(A); Marktanteil=1:J
  for (j in 1:J){Marktanteil[j]=A[j]/Asum}
return(Marktanteil)}

# Funktion zur Berechnung von Gewinnen
Gewinn=function(X,Beta,w,d,f,Regel=1,alpha=1){
  I=dim(Beta)[1]; J=dim(X)[1]
  SDB=d %*% t(X); FK=f %*% t(X)
  P=Prob(X,Beta,Regel,alpha); Gewinn=1:J
  for (j in 1:J){
    Gewinn[j]=-FK[j]
    for (i in 1:I){Gewinn[j]=Gewinn[j]+P[i,j]*w[i]*SDB[i,j]}}
return(Gewinn)}
